<template>
  <b-modal
    id="modal-filters"
    title="Filtrar"
    hide-footer
    centered
    body-class="mobile-filters-body"
  >
    <section>
      <div class="mt-3 py-2">
        <!-- <b-card-body class="p-0" v-if="$route.path != '/'">
          <div
            class="d-flex justify-content-between align-items-center py-3 border-top pl-3 pointer"
            @click="tipoFavorito = !tipoFavorito"
          >
            <span class="small font-weight-bold">Ofertas</span>

            <b-form-checkbox
              class="ml-2 ml-md-0 mr-1 mr-md-3"
              v-model="tipoFavorito"
              @change="tipoFavorito = !tipoFavorito"
            ></b-form-checkbox>
          </div>
        </b-card-body> -->

        <div class="border-top pt-2">
          <b-button
            class="d-flex flex-column justify-content-start align-items-start text-left mf-collapse py-2 pb-3 px-4 bg-white border-0"
            block
            v-b-toggle.accordion-1
          >
            <span class="font-weight-medium small text-dark">Ordenar por:</span>
            <span class="text-primary small">{{ setSubtitle }}</span>
          </b-button>
        </div>

        <b-collapse id="accordion-1" accordion="my-accordion" role="tabpanel">
          <b-card-body class="p-0">
            <div
              class="d-flex justify-content-between align-items-center py-3 border-top pl-5 pointer"
              @click="orden = 0"
            >
              <span
                class="text-option font-weight-medium"
                :class="orden === 0 ? 'text-primary' : 'text-muted'"
                >Más relevantes</span
              >

              <b-form-radio
                class="ml-2 ml-md-0 mr-1 mr-md-3"
                v-model="orden"
                :value="0"
              ></b-form-radio>
            </div>

            <div
              class="d-flex justify-content-between align-items-center py-3 border-top pl-5 pointer"
              @click="orden = 1"
            >
              <span
                class="text-option font-weight-medium"
                :class="orden === 1 ? 'text-primary' : 'text-muted'"
                >Menor precio</span
              >

              <b-form-radio
                class="ml-2 ml-md-0 mr-1 mr-md-3"
                v-model="orden"
                :value="1"
              ></b-form-radio>
            </div>

            <div
              class="d-flex justify-content-between align-items-center py-3 border-top pl-5 pointer"
              @click="orden = 2"
            >
              <span
                class="text-option font-weight-medium"
                :class="orden === 2 ? 'text-primary' : 'text-muted'"
                >Mayor precio</span
              >

              <b-form-radio
                class="ml-2 ml-md-0 mr-1 mr-md-3"
                v-model="orden"
                :value="2"
              ></b-form-radio>
            </div>
          </b-card-body>
        </b-collapse>
      </div>

      <div class="border-top py-2">
        <b-button
          class="d-flex flex-column justify-content-start align-items-start text-left mf-collapse py-2 pb-3 px-4 bg-white border-0"
          block
          v-b-toggle.accordion-2
        >
          <span class="font-weight-medium small text-dark"
            >Rango de precios:</span
          >
        </b-button>

        <b-collapse
          id="accordion-2"
          class="border-top border-bottom pt-3"
          accordion="my-accordion"
          role="tabpanel"
        >
          <b-card-body class="px-0">
            <div class="row justify-content-center">
              <div class="col-4">
                <label for="min" class="text-option text-muted mb-0 ml-3"
                  >Mínimo</label
                >
                <div
                  class="form-group position-relative d-flex align-items-center mt-0 pt-0"
                >
                  <span class="icono-moneda text-muted">S/</span>

                  <div>
                    <input
                      type="number"
                      id="min"
                      class="form-control border-top-0 border-right-0 border-left-0 border-bottom"
                      min="0"
                      :max="max"
                      v-model="min"
                    />
                  </div>
                </div>
              </div>

              <div class="col-4">
                <label for="max" class="text-option text-muted mb-0 ml-3"
                  >Máximo</label
                >
                <div
                  class="form-group position-relative d-flex align-items-center"
                >
                  <span class="icono-moneda text-muted">S/</span>

                  <div>
                    <input
                      type="number"
                      id="max"
                      class="form-control border-top-0 border-right-0 border-left-0 border-bottom"
                      min="0"
                      :max="max"
                      v-model="max"
                    />
                  </div>
                </div>
              </div>
            </div>
          </b-card-body>
        </b-collapse>
      </div>

      <div class="form-group px-4">
        <button
          type="button"
          class="btn btn-success btn-block"
          :disabled="loading"
          @click="submit()"
        >
          {{ loading ? "Filtrando" : "Aplicar" }}
        </button>

        <button type="button" class="btn btn-outline-danger btn-block" @click="cleanUp()">
          Limpiar filtros
        </button>
      </div>
    </section>
  </b-modal>
</template>

<script>
import GetPrecios from "@/graphql/queries/common/GetPrecios.gql";

export default {
  name: "ModalFilters",
  data() {
    return {
      tipoFavorito: 1,
      orden: null,
      min: 0,
      max: 0,
    };
  },
  mounted() {
    this.getPrices();
  },
  props: {
    loading: Boolean,
  },
  components: {},
  methods: {
    async getPrices() {
      let res = await this.$apollo.query({
        query: GetPrecios,
      });

      let prices = res.data.GetPrecios;

      this.min = prices[1];
      this.max = prices[prices.length - 1];
    },
    submit() {
      let valorOrdenAsc = 1;

      let data = {
        precio: [parseFloat(this.min), parseFloat(this.max)],
        categoria_slug: "",
        tipoOrdenacion: "",
        tipoFavorito: this.tipoFavorito
      };

      this.orden
        ? this.orden === valorOrdenAsc
          ? (data.tipoOrdenacion = 1)
          : (data.tipoOrdenacion = 2)
        : (data.tipoOrdenacion = "");

      // Si se encuentra en la página de alguna categoría
      if (this.$route.name === "productos-categorias-slug") {
        data.categoria_slug = this.$route.params.slug;
      }

      this.$emit("filter", data);
    },
    cleanUp() {
      this.$emit("cleanUp");
    },
  },
  computed: {
    setSubtitle: function () {
      let text = "";
      if (this.orden === 0) {
        text = "Más relevantes";
      } else if (this.orden === 1) {
        text = "Menor precio";
      } else if (this.orden === 2) {
        text = "Mayor precio";
      }
      return text;
    },
  },
};
</script>

<style lang="scss">
.mobile-filters-body {
  padding: 0 !important;

  .text-option {
    font-size: 0.8em;
  }
}
</style>
